using EvaPOS_API_FRAME.DTO;
using EvaPosSrvDTO;
using EvaPosSrvResp;
using GatewaySCO;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml;
using System.Xml.Serialization;

namespace EvaPOS_API_FRAME.Adaptadores
{
    /// <summary>
    /// Adaptador para suspender transacción
    /// </summary>
    public class AdaptadorSuspendTransactionRequest : IAdaptadorDTO
    {
        public string Referencia { get; set; } = "scsns:Suspend";
        public string NombreElementoXMLDatos { get; set; } = "./SuspendTransactionRequest";

        public DTOBase ObtieneDTO(int idSesion, TipoMensaje tipoMensaje, XmlElement docXml)
        {
            XmlNode? nodo = docXml.SelectSingleNode(NombreElementoXMLDatos);
            XmlSerializer serializer = new XmlSerializer(typeof(SuspendTransactionRequest));

            SuspendTransactionRequest dto;
            XmlNodeReader elemento = new XmlNodeReader(nodo);

            dto = (SuspendTransactionRequest)serializer.Deserialize(elemento);

            if (nodo == null)
                throw new Exception($"Elemento '{NombreElementoXMLDatos}'.");
            dto.IdSesion = idSesion;
            dto.TipoMensaje = tipoMensaje;
            dto.RequestID = Util.LeeIntEnNodo(nodo, "./RequestID");

            return dto;
        }

        /// <summary>
        /// Retorna una "shallow copy" del objeto.
        /// </summary>
        /// 
        public IAdaptadorDTO CreaCopia()
        {
            return (AdaptadorSuspendTransactionRequest)this.MemberwiseClone();
        }
    }
}
